// This file is distributed under the MIT license.
// See the LICENSE file for details.

#include <visionaray/version.h>

#include <gtest/gtest.h>


// Make version 1.2.3 -------------------------------------

#undef VSNRAY_VERSION_MAJOR
#undef VSNRAY_VERSION_MINOR
#undef VSNRAY_VERSION_PATCH

#define VSNRAY_VERSION_MAJOR 1
#define VSNRAY_VERSION_MINOR 2
#define VSNRAY_VERSION_PATCH 3


//-------------------------------------------------------------------------------------------------
// Test version macros
//

TEST(Version, EQ)
{
    EXPECT_TRUE( VSNRAY_VERSION_EQ(1, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_EQ(0, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_EQ(2, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_EQ(1, 1, 3));
    EXPECT_FALSE(VSNRAY_VERSION_EQ(1, 3, 3));
    EXPECT_FALSE(VSNRAY_VERSION_EQ(1, 2, 2));
    EXPECT_FALSE(VSNRAY_VERSION_EQ(1, 2, 4));
}

TEST(Version, NEQ)
{
    EXPECT_FALSE(VSNRAY_VERSION_NEQ(1, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_NEQ(0, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_NEQ(2, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_NEQ(1, 1, 3));
    EXPECT_TRUE( VSNRAY_VERSION_NEQ(1, 3, 3));
    EXPECT_TRUE( VSNRAY_VERSION_NEQ(1, 2, 2));
    EXPECT_TRUE( VSNRAY_VERSION_NEQ(1, 2, 4));
}

TEST(Version, LT)
{
    EXPECT_FALSE(VSNRAY_VERSION_LT(1, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_LT(0, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_LT(2, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_LT(1, 1, 3));
    EXPECT_TRUE( VSNRAY_VERSION_LT(1, 3, 3));
    EXPECT_FALSE(VSNRAY_VERSION_LT(1, 2, 2));
    EXPECT_TRUE( VSNRAY_VERSION_LT(1, 2, 4));
}

TEST(Version, LE)
{
    EXPECT_TRUE( VSNRAY_VERSION_LE(1, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_LE(0, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_LE(2, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_LE(1, 1, 3));
    EXPECT_TRUE( VSNRAY_VERSION_LE(1, 3, 3));
    EXPECT_FALSE(VSNRAY_VERSION_LE(1, 2, 2));
    EXPECT_TRUE( VSNRAY_VERSION_LE(1, 2, 4));
}

TEST(Version, GT)
{
    EXPECT_FALSE(VSNRAY_VERSION_GT(1, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_GT(0, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_GT(2, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_GT(1, 1, 3));
    EXPECT_FALSE(VSNRAY_VERSION_GT(1, 3, 3));
    EXPECT_TRUE( VSNRAY_VERSION_GT(1, 2, 2));
    EXPECT_FALSE(VSNRAY_VERSION_GT(1, 2, 4));
}

TEST(Version, GE)
{
    EXPECT_TRUE( VSNRAY_VERSION_GE(1, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_GE(0, 2, 3));
    EXPECT_FALSE(VSNRAY_VERSION_GE(2, 2, 3));
    EXPECT_TRUE( VSNRAY_VERSION_GE(1, 1, 3));
    EXPECT_FALSE(VSNRAY_VERSION_GE(1, 3, 3));
    EXPECT_TRUE( VSNRAY_VERSION_GE(1, 2, 2));
    EXPECT_FALSE(VSNRAY_VERSION_GE(1, 2, 4));
}
